#include <iostream>
#include <string>

using namespace std;

// Komplexni cislo s pretizenym operatorem
class Complex{
public:
    double re;
    double im;
    Complex(double _re, double _im){
		this->re = _re;
		im = _im;
    }
    // Nejjednodussi varianta pretizeni operatoru.
    // Pricte jine komplexni cislo k aktualnimu.
    void operator+(Complex &c){
		re += c.re;
		im += c.im;
    }
    void print(){
    	cout << re << " " << im << "i" << endl;
    }
};

// Slozitejsi komplexni cislo s pretizenymi operatory + a =
class Complex2{
	string info;
public:
    double re;
    double im;
    // Bezparametricky konstruktor
	Complex2(){
		re = 0;
		im = 0;
		info += "Prazdne cislo.";
	}
    Complex2(double _re, double _im){
		this->re = _re;
		im = _im;
		info += "Plne cislo.";
    }
    // Nyni chceme, aby pretizeny operator nemenil aktualni objekt
    Complex2 operator+(Complex2 &c){
		Complex2 ret(re + c.re, im + c.im);
		// Proto vratime kopii nove vytvoreneho
		return ret;
    }
    // Neni spatny napad, scitat s realnym cislem (komplexni cislo
    // s imaginarni slozkou 0)
	Complex2 operator+(double c){
		Complex2 ret(re + c, im);
		return ret;
	}
	// Abychom mohli vytvaret plnohodnotne vyrazy s nasim objektem,
	// potrebujeme jeste operator prirazeni.
	void operator=(Complex2 c){
		re = c.re;
		im = c.im;
	}
    void print(){
	cout << re << " " << im << "i" << endl;
    }
    // Pokud chceme mit moznost poslat nase cislo na do standardniho
    // vystupniho proudu, musim pro nej pretizit operator bitoveho
    // posuvu. Tohle je treba provest pomoci fuknce (viz dale). Je
    // to proto, ze pomoci metod lze pretizit operatory, ktere operuji
    // s operandem, ktery obdrzi zprava. Pokud potrebujeme funkcnost na
    // cizim objektu, kteremu predavame nas objekt, tak to lze provest
    // jen pomoci fuknce.
    // Nasleduje deklarace tzv spratelene fukce = fukce, ktera muze
    // pristupovat i k privatnim slozkam tohoto objektu. Definice
    // fukce se uvadi mimo telo tridy.
	friend ostream& operator<<(ostream &out, Complex2 &c);
};

// Nasledujici pretizeni lze definovat pouze pomoci fukce a ne na
// metode. Je to proto, ze pokud mame vyraz "0.3 + complex", tak
// prekladac postupuje pri vyhodnocovani zleva a pro datovy typ
// double nevi jak pricitat objekt typu Complex2.
Complex2 operator+(double c1, Complex2 c2){
	Complex2 ret(c1 + c2.re, c2.im);
	return ret;
}

// Pretizeni operatoru, deklarovane ve tride jako friend. Fukce
// pristoupi k privatnim datum objektu c a posle je standardni
// cestou do vystupniho proudu out. Tento operator nyni funguje
// na vsechny tridy, ktere z tridy ostream dedi.
ostream& operator<<(ostream &out, Complex2 &c){
	//out << c.re << " " << c.im << "i";
	out << c.info << endl;
	return out;
}

int main(){
    Complex a(2, 4), b(1, 3);
	Complex2 c(2, 4), d(1, 3), e;

	// Jednoducha varianta, k cislu a pridej cislo b.
    a + b; // a == 3 + 7i
    a.print();

    // Pokud pretizime operator + pro typ double a operator =,
    // lze vytvaret jiz smysluplne operace:
	e = c + 0.2;
	e.print();
	e = c + d;
	e.print();
	// Zde se pouzije pretizeni operatoru + pomoci funkce.
	e = 0.2 + c;
	e.print();
	// Zde se pouzije pretizeni operatoru << a vlastnost spratelene
	// funkce, ktera si pro info retezec musi sahnout do privatniho
	// prostoru tridy.
	cout << e << endl;

    return 0;
}
